#include "osd_cpu.h"
#include <windows.h>
#include <stdio.h>
#include <shlobj.h>
#include "zlib\zlib.h"
#include "grfiores.h"

#define _chk_(x) MessageBox(0,x,"Message",MB_OK);

#pragma comment(lib,"COMDLG32.LIB")
#pragma comment(lib,"USER32.LIB")
#pragma comment(lib,"GDI32.LIB")
#pragma comment(lib,"zlib\\zlibstat.lib")
#pragma comment(lib,"jpeg\\libjpegs.lib")

UINT8 *GRFIOABOUT1="GRFIO for Ragnarok Online Build 34";

UINT8 *GRFIOABOUT={
"GRFIO for Ragnarok Online Build 34, "__DATE__"\n"
"Copyright 2005 WoWtiger http://wowtiger.24cc.com\n"
"C++ Compiler by\n"
"Microsoft (R) 32-bit C/C++ Optimizing Compiler Version 13.10.3077 for 80x86\n"
"Copyright (C) Microsoft Corporation 1984-2002. All rights reserved.\n"
"gzip Library by\n"
"zlib data compression version 1.2.1, November 17th, 2003\n"
"Copyright (C) 1995-2003 Jean-loup Gailly and Mark Adler\n"
"jpeg Library by\n"
"The IJG JPEG library version 6b, March 22th, 1998\n"
"Copyright (C) 1994-1998, Thomas G. Lane.\n"
"Decode Library by\n"
"Athena Project."};

HINSTANCE hinst;
LVCOLUMN LvCol;
LVITEM LvItem;
LVITEMW LvItemW;

static UINT32 grfver=0;
static UINT32 all_=1;
static UINT32 alllist=1;
static UINT8 LIST_[2048][MAX_PATH];
static UINT8 szTEMP[MAX_PATH];
static UINT8 grfname[MAX_PATH];
static UINT32 bnum,num;
static UINT32 total,off;
static UINT32 bx,by;
static INT32 filelist_hash[MAX_PATH];
static UINT8 grf_header[0x2e];
static UINT32 grf_filelist_off[32768];
static UINT8 *grf_filelist;
static UINT32 grf_filelist_size;
static UINT32 grf_off;
static UINT8 _buf[MAX_PATH];
static UINT32 list_off;

static UINT8 *wowResStr(uLong len)
{
  LoadString(hinst,len,_buf,MAX_PATH);
  return _buf;
}

static struct {
  UINT32 srclen,srclen_aligned,declen,srcpos;
  INT32 next;
  UINT8 cycle,type;
  UINT8 fn[128-4*5];
} *filelist;

#include "grfio.h"
#include "grfiospr.h"
#include "grfiojpg.h"

static void wowOpenFile(HWND hwndDlg,INT32 Num,UINT8 *Nam) {
  OPENFILENAME     ofn;
  UINT8 szFileName[MAX_PATH];
  memset(&ofn,0,sizeof(ofn));
  szFileName[0] = 0;
  ofn.lStructSize = sizeof(ofn);
  ofn.hwndOwner = hwndDlg;
  ofn.Flags = OFN_EXPLORER | OFN_FILEMUSTEXIST | OFN_HIDEREADONLY;
  ofn.lpstrFile = szFileName;
  ofn.nMaxFile = MAX_PATH;
  ofn.lpstrFilter = Nam;

  GetOpenFileName(&ofn);
  SendDlgItemMessage(hwndDlg, Num, WM_SETTEXT ,0, (LPARAM)szFileName);
}

static void wowCreateDir(UINT8 *buf)
{
  INT32 i;
  for(i=0;buf[i]!=0;i++ )
    if(buf[i]=='\\'){
      buf[i]=0;
      CreateDirectory(buf,NULL);
      buf[i]='\\';
    }
}

static INT32 loadlist(HWND hwndDlg,UINT8 *z)
{
  UINT32 s,i,j,y;
  UINT8 tmp[MAX_PATH];
  UINT8 *fn,*buf;
  UINT32 k,h,srclen;
  UINT16 TempU[8][MAX_PATH];
  UINT8 Temp[8][MAX_PATH];
  UINT32 xx=0;

  FILE *fp=fopen(grfname,"rb");
  if(fp==NULL){
    wsprintf(tmp,wowResStr(STR_NOFINDFILE),grfname);
    SendDlgItemMessage(hwndDlg, IDC_LIST, WM_SETTEXT, 0,(LPARAM)tmp);
    return 0;
  }
  fseek(fp,0,2);
  s=ftell(fp);
  fseek(fp,0,0);
  fread(tmp,1,0x2e,fp);
  if(!strstr(tmp,"Master of Magic") || fseek(fp,*(UINT32*)(tmp+0x1e),1)){
    wsprintf(tmp,wowResStr(STR_NOGRF),grfname);
    SendDlgItemMessage(hwndDlg, IDC_LIST, WM_SETTEXT, 0,(LPARAM)tmp);
    return 0;
  }
//  _chk_("Master of Magic")
  grfver=*(UINT32*)(tmp+42);

  s-=ftell(fp);
  buf=malloc(s);
  grf_off=ftell(fp);

  if(buf==NULL){
    wsprintf(tmp,wowResStr(STR_MEM),"grf_filelist");
    SendDlgItemMessage(hwndDlg, IDC_LIST, WM_SETTEXT, 0,(LPARAM)tmp);
    return 0;
  }
//  _chk_("grf_filelist")
  fread(buf,1,s,fp);
  fclose(fp);
  memcpy(grf_header,tmp,0x2e);
  memset(filelist_hash,-1,MAX_PATH);
if(grfver==0x0200){
  INT8 *newindex,*org;
  UINT32 newindexsize=*(unsigned long*)(buf+4);
  bnum=num;
  s=*(unsigned long*)buf;
//  _chk_("newgrf")
  newindex=malloc(newindexsize);
  uncompress(newindex,&newindexsize,buf+8,s);

  grf_filelist_size=newindexsize;
  grf_filelist=malloc(grf_filelist_size);
  memcpy(grf_filelist,newindex,grf_filelist_size);

  filelist=malloc(32768*sizeof(filelist[0]));
  s=0;
  num=0;
  org=newindex;
  while(newindexsize>0){
    UINT8 aaa=0;
    while(*newindex!=0) {
      filelist[s].fn[aaa]=*newindex;
      newindex++;
      newindexsize--;
      aaa++;
    }
    grf_filelist_off[s]=newindex-org+1;
//    _chk_(filelist[s].fn)
    newindex++;
    newindexsize--;
    filelist[s].srclen=*(UINT32*)newindex;
    filelist[s].srclen_aligned=*(UINT32*)(newindex+4);
    filelist[s].declen=*(UINT32*)(newindex+8);
    filelist[s].srcpos=*(UINT32*)(newindex+13)+0x2e;
    filelist[s].cycle=period(filelist[s].fn,*(UINT32*)(newindex+4));
    filelist[s].type=*(newindex+12);
    newindex+=17;
    newindexsize-=17;
    filelist[s].next=filelist_hash[h=filehash(filelist[s].fn)];
    filelist_hash[h]=s;
    num++;
    s++;
  }
  free(org);
} else {
  grf_filelist_size=s;
  grf_filelist=malloc(grf_filelist_size);
  memcpy(grf_filelist,buf,grf_filelist_size);
  bnum=num;
  for(j=0,num=0;j<s;j+=21+*(UINT32*)(buf+j))
    if(buf[j+*(UINT32*)(buf+j)+16]) num++;
  filelist=malloc((num+1024)*sizeof(filelist[0]));
  if(filelist==NULL){
    wsprintf(tmp,wowResStr(STR_MEM),"filelist");
    SendDlgItemMessage(hwndDlg, IDC_LIST, WM_SETTEXT, 0,(LPARAM)tmp);
    return 0;
  }
  for(i=0,j=0;i<num;i++,j+=21+*(UINT32*)(buf+j)){
    grf_filelist_off[i]=j;
    k=j+*(UINT32*)(buf+j)+4;
    if(buf[k+12]==0){
      i--;
      continue;
    }
    fn=decode_filename(buf+j+6,buf[j]-6);
    if(strlen(fn)>=sizeof(filelist[i].fn)-1)
      break;
    srclen=*(UINT32*)(buf+k)-*(UINT32*)(buf+k+8)-715;

    filelist[i].srclen=srclen;
    filelist[i].srclen_aligned=*(UINT32*)(buf+k+4)-37579;
    filelist[i].declen=*(UINT32*)(buf+k+8);
    filelist[i].srcpos=*(UINT32*)(buf+k+13)+0x2e;
    filelist[i].cycle=period(fn,srclen);
    filelist[i].type=buf[k+12];
    strcpy(filelist[i].fn,fn);
    filelist[i].next=filelist_hash[h=filehash(fn)];
    filelist_hash[h]=i;
  }
}
  sprintf(tmp,wowResStr(STR_GRFVER),(grfver&0xff00)>>8,grfver&0xff);
  SendDlgItemMessage(hwndDlg, IDC_TYPE, WM_SETTEXT, 0,(LPARAM)tmp);
  free(buf);
if (GetVersion() < 0x80000000) {
  memset(&LvItemW,0,sizeof(LvItemW));
  LvItemW.mask=LVIF_TEXT;
  LvItemW.cchTextMax = MAX_PATH;
} else {
  memset(&LvItem,0,sizeof(LvItem));
  LvItem.mask=LVIF_TEXT;
  LvItem.cchTextMax = MAX_PATH;
}
  for ( i=0 ; i<num ; i++ ) {
    if ( i % 256 == 0 ) {
if (GetVersion() < 0x80000000) {
      wsprintfW(TempU[0],L"%ld/%ld",i+1,num);
      SendDlgItemMessageW(hwndDlg, IDC_LIST, WM_SETTEXT, 0,(LPARAM)TempU[0]);
} else {
      wsprintf(Temp[0],"%ld/%ld",i+1,num);
      SendDlgItemMessage(hwndDlg, IDC_LIST, WM_SETTEXT, 0,(LPARAM)Temp[0]);
}
    }
      if (strstr(filelist[i].fn,z)||z[0]=='*') {
if (GetVersion() < 0x80000000) {
      wsprintfW(TempU[0],L"%ld",i);
      wsprintfW(TempU[1],L"%ld",filelist[i].srclen);
      wsprintfW(TempU[2],L"%ld",filelist[i].srclen_aligned);
      wsprintfW(TempU[3],L"%ld",filelist[i].declen);
      wsprintfW(TempU[4],L"%ld",filelist[i].srcpos);
      wsprintfW(TempU[5],L"%d",filelist[i].cycle);
      wsprintfW(TempU[6],L"%d",filelist[i].type);
      MultiByteToWideChar(949,0,filelist[i].fn,108,TempU[7],108);
      LvItemW.iItem=xx;
      LvItemW.iSubItem=0;
      LvItemW.pszText=TempU[0];
} else {
      wsprintf(Temp[0],"%ld",i);
      wsprintf(Temp[1],"%ld",filelist[i].srclen);
      wsprintf(Temp[2],"%ld",filelist[i].srclen_aligned);
      wsprintf(Temp[3],"%ld",filelist[i].declen);
      wsprintf(Temp[4],"%ld",filelist[i].srcpos);
      wsprintf(Temp[5],"%d",filelist[i].cycle);
      wsprintf(Temp[6],"%d",filelist[i].type);
      wsprintf(Temp[7],"%s",filelist[i].fn);
      LvItem.iItem=xx;
      LvItem.iSubItem=0;
      LvItem.pszText=Temp[0];
}
if (GetVersion() < 0x80000000) {
      if ( xx < bnum )
        SendDlgItemMessageW(hwndDlg,IDC_LISTVIEW,LVM_SETITEMW,0,(LPARAM)&LvItemW);
      else
        SendDlgItemMessageW(hwndDlg,IDC_LISTVIEW,LVM_INSERTITEMW,0,(LPARAM)&LvItemW);
} else {
      if ( xx < bnum )
        SendDlgItemMessage(hwndDlg,IDC_LISTVIEW,LVM_SETITEM,0,(LPARAM)&LvItem);
      else
        SendDlgItemMessage(hwndDlg,IDC_LISTVIEW,LVM_INSERTITEM,0,(LPARAM)&LvItem);
}
      for ( y=1 ; y < 8 ; y++ ) {
if (GetVersion() < 0x80000000) {
        LvItemW.iSubItem=y;
        LvItemW.pszText=TempU[y];
        SendDlgItemMessageW(hwndDlg,IDC_LISTVIEW,LVM_SETITEMW,0,(LPARAM)&LvItemW);
} else {
        LvItem.iSubItem=y;
        LvItem.pszText=Temp[y];
        SendDlgItemMessage(hwndDlg,IDC_LISTVIEW,LVM_SETITEM,0,(LPARAM)&LvItem);
}
      }
      xx++;
    }
    if ( GetAsyncKeyState(VK_ESCAPE)==-32767 )
      break;
    UpdateWindow(hwndDlg);
  }
  num=xx;
  for ( i=num ; i<bnum ; i++ ) {
    SendDlgItemMessage(hwndDlg,IDC_LISTVIEW,LVM_DELETEITEM,num,0);
    if ( i % 256 == 0 ) {
if (GetVersion() < 0x80000000) {
      wsprintfW(TempU[0],L"%ld/%ld",num+1,bnum-i+num);
      SendDlgItemMessageW(hwndDlg, IDC_LIST, WM_SETTEXT, 0,(LPARAM)TempU[0]);
} else {
      wsprintf(Temp[0],"%ld/%ld",num+1,bnum-i+num);
      SendDlgItemMessage(hwndDlg, IDC_LIST, WM_SETTEXT, 0,(LPARAM)Temp[0]);
}
    }
    if ( GetAsyncKeyState(VK_ESCAPE)==-32767 )
      break;
    UpdateWindow(hwndDlg);
  }
  SendDlgItemMessage(hwndDlg,IDC_LIST,WM_SETTEXT,0,(LPARAM)wowResStr(STR_LIST));
  return 0;
}

static void showbitmap(HWND hwndDlg,INT32 a){
  if ( (off >= total-1&&a==1)||(off==0&&a==-1) )
    a=0;
  off+=a;
  if ( total > 0 ) {
  HWND hwndShow;
  BITMAP bmpinfo;
  HDC hSrcDC,hDestDC;
  HBITMAP hbitmap;
  RECT rc;
    UINT8 numx[MAX_PATH];
    wsprintf(numx,wowResStr(STR_D_D),off+1,total);
    SendDlgItemMessage(hwndDlg ,306 ,WM_SETTEXT ,0, (LPARAM)numx);
    wsprintf(numx,"%s\\%03d%s",szTEMP,off,".bmp");
  hwndShow=CreateWindow(NULL,NULL,WS_CLIPCHILDREN,0,0,0,0,NULL,NULL,hinst,NULL);
  hbitmap = (HBITMAP)LoadImage(
NULL, numx, IMAGE_BITMAP, 0, 0,LR_CREATEDIBSECTION | LR_LOADFROMFILE);
  hSrcDC = CreateCompatibleDC(NULL);
  SelectObject(hSrcDC, hbitmap);
  GetObject(hbitmap, sizeof(BITMAP), &bmpinfo);
  hDestDC = GetDC(hwndShow);
  rc.left = 0;
  rc.top = 0;
  rc.right = bx;
  rc.bottom = by;
  FillRect(hDestDC, &rc, (HBRUSH)(COLOR_BTNFACE+1));
  BitBlt(hDestDC, 0, 0, bx=bmpinfo.bmWidth, by=bmpinfo.bmHeight, hSrcDC, 0, 0, SRCCOPY);
  ReleaseDC(hwndShow, hDestDC);
  DeleteObject(hbitmap);
  DeleteDC(hSrcDC);
  }
}

//static INT32 InitializeApp(HWND hwndDlg,WPARAM wParam, LPARAM lParam)
//{
//  return 1;
//}

static BOOL CALLBACK DialogFunc(HWND hwndDlg, UINT msg, WPARAM wParam, LPARAM lParam) {
switch (msg) {
  case WM_INITDIALOG:{
    INT32 y;
    UINT32 listsize[]={40,60,60,60,80,40,40,306};
//    InitializeApp(hwndDlg,wParam,lParam);
    SetWindowText(hwndDlg,GRFIOABOUT1);
    //*(GRFIOABOUT+34)=',';
    GetTempPath(MAX_PATH,szTEMP);
    if (szTEMP[0]==0) {
      wsprintf(szTEMP,wowResStr(STR_CAUTION));
      MessageBox(hwndDlg,wowResStr(STR_TEMP),szTEMP,MB_OK);
      exit(0);//ExitProcess(0);
    }
    SendDlgItemMessage(hwndDlg,IDC_LISTVIEW,LVM_SETEXTENDEDLISTVIEWSTYLE,0,LVS_EX_FULLROWSELECT);
    memset(&LvCol,0,sizeof(LvCol));
    LvCol.mask=LVCF_TEXT|LVCF_WIDTH|LVCF_SUBITEM;
    for ( y=0 ; y < 8 ; y++ ) {
      LvCol.cx=listsize[y];
      LvCol.pszText=wowResStr(STR_LISTNAME)+y*5;
      SendDlgItemMessage(hwndDlg,IDC_LISTVIEW,LVM_INSERTCOLUMN,y,(LPARAM)&LvCol);
    }
    return TRUE;
  }
  case WM_COMMAND:
    switch (LOWORD(wParam)) {
  case 101: {
    MessageBox(hwndDlg,GRFIOABOUT,"About GRFIO",MB_OK);
    break;
  }
  case 102: {
    UINT8 z[MAX_PATH];
    SendDlgItemMessage(hwndDlg, 304, WM_GETTEXT, MAX_PATH,(LPARAM)z);
    if ( grfname[0]==0 )
      SendDlgItemMessage(hwndDlg, IDC_LIST, WM_SETTEXT, 0,(LPARAM)wowResStr(STR_NOGRFFILE));
    else {
      UINT32 s,f,x;
      UINT8 l[MAX_PATH];
      UINT8 *buf;
      FILE *fout;
      for ( f=0;f<num;f++ ) {
        wsprintf(l,filelist[f].fn);
        for ( x=0 ; l[x]!='.'&&l[x]!=0 ; x++);
        if ((l[x+1]==z[0]&&l[x+2]==z[1]&&l[x+3]==z[2])||z[0]=='*') {
          buf=malloc(filelist[f].declen+1024);
          grfio_read(filelist[f].fn,buf);
          s=grfio_size(filelist[f].fn);
          fout=fopen(filelist[f].fn,"wb");
//          FILE *fout=fopen("\\grfio.chk","wb");
          if ( !fout ) {
            wowCreateDir(filelist[f].fn);
            fout=fopen(filelist[f].fn,"wb");
          }
          if ( !fout )
            SendDlgItemMessage(hwndDlg, IDC_LIST, WM_SETTEXT, 0,(LPARAM)wowResStr(STR_FOLDER));
          else {
            fwrite(buf,1,s,fout);
            fclose(fout);
            wsprintf(l,wowResStr(STR_EXTRACT),filelist[f].fn);
            SendDlgItemMessage(hwndDlg, IDC_LIST, WM_SETTEXT, 0,(LPARAM)l);
          }
          free(buf);
        }
        if ( GetAsyncKeyState(VK_ESCAPE)==-32767 )
          break;
        UpdateWindow(hwndDlg);
      }
    }
    break;
  }
  case 103:
    exit(0);//ExitProcess(0);
  case 110: {
    UINT8 zz[MAX_PATH],z[8];
    SendDlgItemMessage(hwndDlg, IDC_COMP, WM_GETTEXT, 8,(LPARAM)z);
    SendDlgItemMessage(hwndDlg, 304, WM_GETTEXT, MAX_PATH,(LPARAM)zz);
    if (grfname[0]==0)
      SendDlgItemMessage(hwndDlg, IDC_LIST, WM_SETTEXT, 0,(LPARAM)wowResStr(STR_NOGRFFILE));
    else if (strstr(grfname,"grfio.grf"))
      SendDlgItemMessage(hwndDlg, IDC_LIST, WM_SETTEXT, 0,(LPARAM)wowResStr(STR_GRFIOGRF));
    else if (z[0]>0x39||z[0]<0x30)
      SendDlgItemMessage(hwndDlg, IDC_LIST, WM_SETTEXT, 0,(LPARAM)wowResStr(STR_SETUP));
//    else if (newgrf==1)
//      SendDlgItemMessage(hwndDlg, IDC_LIST, WM_SETTEXT, 0,(LPARAM)wowResStr(STR_NEWGRF));
    else {
      UINT8 *src,*dest,srccount,newgrfname[MAX_PATH];
      UINT32 srcLen=0,destLen,k,addup,xxxx;
      UINT32 off=0,f;
      FILE *fp;
      while(grfname[srcLen]!=0) srcLen++;
      while(grfname[srcLen]!='\\') srcLen--;
      grfname[srcLen]=0;
      wsprintf(newgrfname,"%s\\%s",grfname,"grfio.grf");
      grfname[srcLen]='\\';
      fp=fopen(newgrfname,"wb");
      fwrite(grf_header,1,0x2e,fp);
      for ( f=0;f<num;f++ ) {
        srcLen=filelist[f].declen;
        src=malloc(srcLen);
        dest=malloc(srcLen+1024);
        destLen=srcLen+1024;

        grfio_read(filelist[f].fn,src);

        wsprintf(dest,"%ld/%ld",f+1,num);
        SendDlgItemMessage(hwndDlg, IDC_LIST, WM_SETTEXT, 0,(LPARAM)dest);
        UpdateWindow(hwndDlg);

        compress2(dest,&destLen,src,srcLen,z[0]-0x30);
        if(grfver==0x0200) {

          k=grf_filelist_off[f];

          *(UINT32*)(grf_filelist+k)=destLen;
          *(UINT32*)(grf_filelist+k+4)=destLen;
          *(UINT32*)(grf_filelist+k+8)=srcLen;
          *(UINT8*)(grf_filelist+k+12)=1;
          *(UINT32*)(grf_filelist+k+13)=off;

          off+=destLen;

          fwrite(dest,1,destLen,fp);
        } else {
          srccount=period(filelist[f].fn,destLen);

          decode_des_etc(dest,destLen,srccount==0,srccount,1);

          k=grf_filelist_off[f];
          k+=grf_filelist[k]+4;
          addup=8-destLen%8;
          if (addup==8) addup=0;

          *(UINT32*)(grf_filelist+k)=destLen+srcLen+715;
          *(UINT32*)(grf_filelist+k+4)=destLen+37579+addup;
          *(UINT32*)(grf_filelist+k+8)=srcLen;
          *(UINT32*)(grf_filelist+k+13)=off;

          off+=destLen+addup;

          fwrite(dest,1,destLen+addup,fp);
        }
        free(src);
        free(dest);
      }
      xxxx=ftell(fp)-0x2e;
      if(grfver==0x0200){
        UINT32 tmp2=grf_filelist_size;
        UINT8 *tmp1=malloc(grf_filelist_size);
        compress2(tmp1,&tmp2,grf_filelist,grf_filelist_size,z[0]-0x30);
        fwrite((char*)&tmp2,1,4,fp);
        fwrite((char*)&grf_filelist_size,1,4,fp);
        fwrite(tmp1,1,tmp2,fp);
      } else
        fwrite(grf_filelist,1,grf_filelist_size,fp);
      fseek(fp,0x1e,0);
      fwrite((UINT8*)&xxxx,1,4,fp);
      fclose(fp);

      wsprintf(grfname,newgrfname);
      SendDlgItemMessage(hwndDlg, IDC_PATH, WM_SETTEXT ,0, (LPARAM)grfname);
      loadlist(hwndDlg,zz);
    }
    break;
  }
  case 111: {
    UINT8 x[MAX_PATH],y[MAX_PATH],z[8],zz[MAX_PATH];
  UINT32 c,size;
  UINT8 *buf;
  FILE *fp;
  if(SendDlgItemMessage(hwndDlg, 310,BM_GETCHECK,0,0)==BST_CHECKED){
    wowOpenFile(hwndDlg,301,wowResStr(STR_INI));
    SendDlgItemMessage(hwndDlg, IDC_LIST, WM_GETTEXT, MAX_PATH,(LPARAM)y);
  fp=fopen(y,"rb");
  if ( fp ) {
    fseek(fp,0,2);
    size=ftell(fp);
    buf=malloc(size);
    fseek(fp,0,0);
    fread(buf,1,size,fp);
    fclose(fp);

    for(alllist=0,c=0;size--;buf++){
      if(*(UINT8*)buf!='\r'&&*(UINT8*)buf!='\n'&&*(UINT8*)buf!='\t'){
        if(*(UINT8*)buf=='#'){
          alllist++;
          c=0;
        }
        else
          *(UINT8*)(LIST_[alllist]+(c++))=*(UINT8*)buf;
      }
    }
    all_=alllist-alllist%2;
    wsprintf(buf,"%s %ld",wowResStr(STR_CAUTION),all_);
    MessageBox(hwndDlg,wowResStr(STR_INIEXE),buf,MB_OK);
    free(buf); 
  }
    }
    else {
      wowOpenFile(hwndDlg,301,wowResStr(STR_ALL));
      SendDlgItemMessage(hwndDlg, IDC_LIST, WM_GETTEXT, MAX_PATH,(LPARAM)y);
    }
    SendDlgItemMessage(hwndDlg, IDC_EDIT, WM_GETTEXT, MAX_PATH,(LPARAM)x);
    SendDlgItemMessage(hwndDlg, IDC_COMP, WM_GETTEXT, 8,(LPARAM)z);
    SendDlgItemMessage(hwndDlg, 304, WM_GETTEXT, MAX_PATH,(LPARAM)zz);
    if (grfname[0]==0)
      SendDlgItemMessage(hwndDlg, IDC_LIST, WM_SETTEXT, 0,(LPARAM)wowResStr(STR_NOGRFFILE));
    else if ((x[0]==0||y[0]==0)&&all_<=1)
      SendDlgItemMessage(hwndDlg, IDC_LIST, WM_SETTEXT, 0,(LPARAM)wowResStr(STR_NOSPEC));
    else if (z[0]>0x39||z[0]<0x30)
      SendDlgItemMessage(hwndDlg, IDC_LIST, WM_SETTEXT, 0,(LPARAM)wowResStr(STR_SETUP));
//    else if (newgrf==1)
//      SendDlgItemMessage(hwndDlg, IDC_LIST, WM_SETTEXT, 0,(LPARAM)wowResStr(STR_NEWGRF));
    else {
    UINT32   srcLen,destLen,k,addup,xxxx,list,f;
    UINT8   *src,*dest,srccount;
    FILE *fp;
    for(list=0;list<all_;list+=2){
      if(all_>=2) {
        memcpy(x,LIST_[list],MAX_PATH);
        memcpy(y,LIST_[list+1],MAX_PATH);
      }
      for(f=filelist_hash[filehash(x)];f>=0;f=filelist[f].next)
        if(strstr(filelist[f].fn,x))
          break;

      fp=fopen(y,"rb");
      fseek(fp,0,2);
      srcLen=ftell(fp);
      destLen=ftell(fp)+1024;
      src=malloc(srcLen);
      dest=malloc(srcLen+1024);
      fseek(fp,0,0);
      fread(src,1,srcLen,fp);
      fclose(fp);

      compress2(dest,&destLen,src,srcLen,z[0]-0x30);
      if(grfver==0x0200) {
        k=grf_filelist_off[f];

        *(UINT32*)(grf_filelist+k)=destLen;
        *(UINT32*)(grf_filelist+k+4)=destLen;
        *(UINT32*)(grf_filelist+k+8)=srcLen;
        *(UINT8*)(grf_filelist+k+12)=1;
        *(UINT32*)(grf_filelist+k+13)=grf_off-0x2e;

        xxxx=grf_off+destLen-0x2e;
      } else {
        srccount=period(x,destLen);

        decode_des_etc(dest,destLen,srccount==0,srccount,1);

        k=grf_filelist_off[f];
        k+=grf_filelist[k]+4;
        addup=8-destLen%8;
        if (addup==8) addup=0;

        *(UINT32*)(grf_filelist+k)=destLen+srcLen+715;
        *(UINT32*)(grf_filelist+k+4)=destLen+37579+addup;
        *(UINT32*)(grf_filelist+k+8)=srcLen;
        *(UINT32*)(grf_filelist+k+13)=grf_off-0x2e;

        xxxx=grf_off+destLen+addup-0x2e;
      }
      fp=fopen(grfname,"rb+");
      fseek(fp,0x1e,0);
      fwrite((UINT8*)&xxxx,1,4,fp);
      fseek(fp,grf_off,0);
      if(grfver==0x0200){
        UINT32 tmp2=grf_filelist_size;
        UINT8 *tmp1=malloc(grf_filelist_size);
        fwrite(dest,1,destLen,fp);
        compress2(tmp1,&tmp2,grf_filelist,grf_filelist_size,z[0]-0x30);
        fwrite((char*)&tmp2,1,4,fp);
        fwrite((char*)&grf_filelist_size,1,4,fp);
        fwrite(tmp1,1,tmp2,fp);
      } else {
        fwrite(dest,1,destLen+addup,fp);
        fwrite(grf_filelist,1,grf_filelist_size,fp);
      }
      fclose(fp);
      free(src);
      free(dest);
    }
    loadlist(hwndDlg,zz);
    }
    break;
  }
  case 112: {
    UINT8 x[MAX_PATH];
    SendDlgItemMessage(hwndDlg, IDC_EDIT, WM_GETTEXT, MAX_PATH,(LPARAM)x);
    if (x[0]==0)
      SendDlgItemMessage(hwndDlg, IDC_LIST, WM_SETTEXT, 0,(LPARAM)wowResStr(STR_NOSPEC));
    else if (grfname[0]==0)
      SendDlgItemMessage(hwndDlg, IDC_LIST, WM_SETTEXT, 0,(LPARAM)wowResStr(STR_NOGRFFILE));
    else {
      UINT32 s=grfio_size(x);
      UINT8 *buf=malloc(s);
      FILE *fout;
      grfio_read(x,buf);

      fout=fopen(x,"wb");
      if ( !fout ) {
        wowCreateDir(x);
        fout=fopen(x,"wb");
      }
      if ( !fout )
        SendDlgItemMessage(hwndDlg, IDC_LIST, WM_SETTEXT, 0,(LPARAM)wowResStr(STR_FOLDER));
      else {
        fwrite(buf,1,s,fout);
        fclose(fout);
        wsprintf(x,wowResStr(STR_EXTRACT),x);
        SendDlgItemMessage(hwndDlg, IDC_LIST, WM_SETTEXT, 0,(LPARAM)x);
      }
      free(buf);
    }
    break;
  }
  case 113: {
    showbitmap(hwndDlg,-1);
    break;
  }
  case 114: {
    showbitmap(hwndDlg,1);
    break;
  }
  case 150: {
    UINT8 z[MAX_PATH];
    SendDlgItemMessage(hwndDlg, 304, WM_GETTEXT, MAX_PATH,(LPARAM)z);
    wowOpenFile(hwndDlg,300,wowResStr(STR_GRF));
    SendDlgItemMessage(hwndDlg, IDC_PATH, WM_GETTEXT, MAX_PATH,(LPARAM)grfname);
    if ( grfname[0]==0 )
      SendDlgItemMessage(hwndDlg, IDC_LIST, WM_SETTEXT, 0,(LPARAM)wowResStr(STR_NOGRFFILE));
    else
      loadlist(hwndDlg,z);
    break;
  }
}
break;
  case WM_NOTIFY:
    switch(LOWORD(wParam)) {
  case IDC_LISTVIEW: {
    if (grfname[0]!=0&&num>0){
      UINT32 xx=SendDlgItemMessage(hwndDlg,IDC_LISTVIEW,LVM_GETNEXTITEM,-1,LVNI_FOCUSED);
      if ( list_off!=xx){
      FILE *fout;
      UINT32 s;
      UINT8 *buf;
      UINT8 Text[MAX_PATH];
      UINT16 TextU[MAX_PATH];
      list_off=xx;
  if (xx<=num){
if (GetVersion() < 0x80000000) {
      memset(&LvItemW,0,sizeof(LvItemW));
      LvItemW.mask=LVIF_TEXT;
      LvItemW.cchTextMax=MAX_PATH;
      LvItemW.iItem=xx;
      LvItemW.iSubItem=7;
      LvItemW.pszText=TextU;

      SendDlgItemMessageW(hwndDlg,IDC_LISTVIEW,LVM_GETITEMTEXTW, xx ,(LPARAM)&LvItemW);
      WideCharToMultiByte(949,0,TextU,MAX_PATH,Text,MAX_PATH,NULL,NULL);
} else {
      memset(&LvItem,0,sizeof(LvItem));
      LvItem.mask=LVIF_TEXT;
      LvItem.cchTextMax=MAX_PATH;
      LvItem.iItem=xx;
      LvItem.iSubItem=7;
      LvItem.pszText=Text;

      SendDlgItemMessage(hwndDlg,IDC_LISTVIEW,LVM_GETITEMTEXT, xx ,(LPARAM)&LvItem);
}
      SendDlgItemMessage(hwndDlg, IDC_EDIT, WM_SETTEXT, 0,(LPARAM)Text);

      if (strstr(Text,".spr")) {
        s=grfio_size(Text);
        buf=malloc(s);
        grfio_read(Text,buf);

        wsprintf(Text,"%s\\%03d%s",szTEMP,0,".spr");
        fout=fopen(Text,"wb");
        fwrite(buf,1,s,fout);
        fclose(fout);
        sprmain(hwndDlg);
        showbitmap(hwndDlg,0);
        free(buf);
      }
      else if (strstr(Text,".bmp")) {
        s=grfio_size(Text);
        buf=malloc(s);
        grfio_read(Text,buf);

        wsprintf(Text,"%s\\%03d%s",szTEMP,0,".bmp");
        fout=fopen(Text,"wb");
        fwrite(buf,1,s,fout);
        fclose(fout);
        wsprintf(Text,wowResStr(STR_D_D),(off=0)+1,total=1);
        SendDlgItemMessage(hwndDlg ,306 ,WM_SETTEXT ,0, (LPARAM)Text);
        showbitmap(hwndDlg,0);
        free(buf);
      }
      else if (strstr(Text,".tga")) {
UINT32 x,y,addup;
UINT8 bmp[54],*fn;
memcpy(bmp,_BMP,54);
        s=grfio_size(Text);
        buf=malloc(s);
        grfio_read(Text,buf);

x=*(UINT16*)(buf+12);
y=*(UINT16*)(buf+14);
wsprintf(Text,wowResStr(STR_SPRMSG),"32 ",1,x,y,0,20);
SendDlgItemMessage(hwndDlg, IDC_LIST, WM_SETTEXT ,0, (LPARAM)Text);
wsprintf(Text,"%s\\%03d%s",szTEMP,0,".bmp");
fout=fopen(Text,"wb");
*((INT32*)(bmp+18))=x;
*((INT32*)(bmp+22))=y;
addup=4-(x%4);
if (addup==4) addup=0;
*((UINT32*)(bmp+2))=(x+addup)*y*4+54;
*((UINT32*)(bmp+34))=(x+addup)*y*4;
*((UINT8*)(bmp+11))=0;
*((UINT8*)(bmp+28))=32;
fn=malloc((x+addup)*y*4);
fwrite(bmp,1,54,fout);
fwrite(buf+18,1,(x+addup)*y*4,fout);
fclose(fout);
free(fn);
        wsprintf(Text,wowResStr(STR_D_D),(off=0)+1,total=1);
        SendDlgItemMessage(hwndDlg ,306 ,WM_SETTEXT ,0, (LPARAM)Text);
        showbitmap(hwndDlg,0);
        free(buf);
      }
      else if (strstr(Text,".jpg")) {
        s=grfio_size(Text);
        buf=malloc(s);
        grfio_read(Text,buf);

        wsprintf(Text,"%s\\%03d%s",szTEMP,0,".jpg");
        fout=fopen(Text,"wb");
        fwrite(buf,1,s,fout);
        fclose(fout);
        jpgmain(hwndDlg);
        wsprintf(Text,wowResStr(STR_D_D),(off=0)+1,total=1);
        SendDlgItemMessage(hwndDlg ,306 ,WM_SETTEXT ,0, (LPARAM)Text);
        showbitmap(hwndDlg,0);
        free(buf);
      } 
      else if (strstr(Text,".wav")) {
        s=grfio_size(Text);
        buf=malloc(s);
        grfio_read(Text,buf);

        wsprintf(Text,"%s\\%03d%s",szTEMP,0,".wav");
        fout=fopen(Text,"wb");
        fwrite(buf,1,s,fout);
        fclose(fout);
//        jpgmain(hwndDlg);
//        wsprintf(Text,wowResStr(STR_D_D),(off=0)+1,total=1);
//        SendDlgItemMessage(hwndDlg ,306 ,WM_SETTEXT ,0, (LPARAM)Text);
//        showbitmap(hwndDlg,0);
//        free(buf);
        PlaySound(Text,NULL,SND_FILENAME||SND_ASYNC);
      }
  }
        break;
      }
    if ( GetAsyncKeyState(VK_LEFT)==-32767 )
      showbitmap(hwndDlg,-1);
    if ( GetAsyncKeyState(VK_RIGHT)==-32767 )
      showbitmap(hwndDlg,1);
    switch (((LPNMHDR)lParam)->code ) {
  case NM_DBLCLK: {
    UINT8 Text[MAX_PATH],*buf;
    UINT16 TextU[MAX_PATH];
    UINT32 x,s;
    FILE *fout;
    if (grfname[0]!=0){
      x=SendDlgItemMessage(hwndDlg,IDC_LISTVIEW,LVM_GETNEXTITEM,-1,LVNI_FOCUSED);
if (GetVersion() < 0x80000000) {
      memset(&LvItemW,0,sizeof(LvItemW));
      LvItemW.mask=LVIF_TEXT;
      LvItemW.cchTextMax=MAX_PATH;
      LvItemW.iItem=x;
      LvItemW.iSubItem=7;
      LvItemW.pszText=TextU;

      SendDlgItemMessageW(hwndDlg,IDC_LISTVIEW,LVM_GETITEMTEXTW, x ,(LPARAM)&LvItemW);
      WideCharToMultiByte(949,0,TextU,MAX_PATH,Text,MAX_PATH,NULL,NULL);
} else {
      memset(&LvItem,0,sizeof(LvItem));
      LvItem.mask=LVIF_TEXT;
      LvItem.cchTextMax=MAX_PATH;
      LvItem.iItem=x;
      LvItem.iSubItem=7;
      LvItem.pszText=Text;

      SendDlgItemMessage(hwndDlg,IDC_LISTVIEW,LVM_GETITEMTEXT, x ,(LPARAM)&LvItem);
}
      s=grfio_size(Text);
      buf=malloc(s);
      grfio_read(Text,buf);

      fout=fopen(Text,"wb");
      if ( !fout ) {
        wowCreateDir(Text);
        fout=fopen(Text,"wb");
      }
      if ( !fout )
        SendDlgItemMessage(hwndDlg, IDC_LIST, WM_SETTEXT, 0,(LPARAM)wowResStr(STR_FOLDER));
      else {
        fwrite(buf,1,s,fout);
        fclose(fout);
        wsprintf(Text,wowResStr(STR_EXTRACT),Text);
        SendDlgItemMessage(hwndDlg, IDC_LIST, WM_SETTEXT, 0,(LPARAM)Text);
      }
    free(buf);
    }
    break;
  }
    }
}
  }
}
break;
  case WM_CLOSE:
    exit(0);//ExitProcess(0);
}
return FALSE;
}

int APIENTRY WinMain(HINSTANCE hinst, HINSTANCE hinstPrev, LPSTR lpCmdLine, int nCmdShow)
//void wowWinMain()
{
  DialogBox(hinst, MAKEINTRESOURCE(100), NULL, (DLGPROC) DialogFunc);
}

//void main(){}